
package dialog;
import tm2.*;

import java.awt.*;
import mdgawt.*;
import java.awt.event.*;
import java.io.*;

public class AlphabetDialog extends Dialog implements ActionListener,
                                                      ItemListener{
// --------------------------INSTANCE DATA-----------------------------------
   TMG tmg;
   CharacterSelector blank,wildcard,copy,lambda;
   Panel p1,p2,p3,p4,p5,p6;
   Label lc,l,cs;
   Button b,apply;
   public AlphabetDialog(TMG t){
      super(t.myFrame,"Alphabet",true);
      tmg=t;
      setResizable(false);
      setLayout(new BorderLayout(4,4));
      setLocation(10,10);
      Ins.alphabet.updateCheckboxes();
      String abc = Ins.alphabet.getAlphabet();
      setSize(600,((int)Math.sqrt(Alphabet.ap.getComponentCount()))*24+200);
      p1 = new Panel();
         p1.setSize(600,24);
         p1.setLayout(new FlowLayout(1,4,4));
         String[] names={"Select characters","Select digits","Select used",
                         "Select all","Unselect all","Apply","Ok","Cancel"};
         for(int i=0;i<8;i++){
            b = new Button(names[i]);
            b.addActionListener(this);
            p1.add(b);}
      p2 = new Panel();
         p2.setSize(600,16);
         p2.setLayout(new FlowLayout(1,0,0));
         blank    = new CharacterSelector(abc);
         copy     = new CharacterSelector(abc);
         wildcard = new CharacterSelector(abc);
         lambda = new CharacterSelector(abc);
         blank.setSelected(Ins.alphabet.blank);
         copy.setSelected(Ins.alphabet.copy);
         wildcard.setSelected(Ins.alphabet.wildcard);
         lambda.setSelected(Ins.alphabet.lambda);
         p2.add(new Label("Blank"));
         p2.add(blank);
         if(TMG.copysOn){
            p2.add(new Label("   "));
            p2.add(new Label("Copy"));
            p2.add(copy);}
         if(TMG.wildcardsOn){
            p2.add(new Label("   "));
            p2.add(new Label("Wildcard"));
            p2.add(wildcard);}
         if(tmg.getType()==TMG.NFA){
            p2.add(new Label("   "));
            p2.add(new Label("Lambda"));
            p2.add(lambda);}
      p4 = new Panel();
         p4.setSize(600,16);
         p4.setLayout(new FlowLayout(1,0,0));
         p4.add(new Label("Current used -> "+TMG.getUsedAlphabet()));
      p3 = new Panel();
         p3.setSize(600,16);
         p3.setLayout(new FlowLayout(1,0,0)); 
         lc = new Label("Current alphabet ->  " + abc);
         p3.add("Center",lc);   
      p6 = new Panel();
         p6.setSize(600,16);
         p6.setLayout(new FlowLayout(1,0,0));
         cs = new Label("Current selected -> "+Ins.alphabet.getSelected());
         p6.add("Center",cs);   
      p5 = new Panel();
         p5.setSize(600,72);
         p5.setLayout(new GridLayout(5,1,0,0));
         p5.add(p4);
         p5.add(p3);
         p5.add(p6);
         p5.add(p2);
         p5.add(p1);
      add("Center",Ins.alphabet.ap);
      add("South",p5);
      Ins.alphabet.addItemListener(this);
      setVisible(true);}
// ---------------------------------EVENTS-------------------------------------
   public void itemStateChanged(ItemEvent e){
      Object o = e.getSource();
      String c = ((Checkbox)o).getLabel();
      boolean s = ((Checkbox)o).getState();
      cs.setText("Current selected -> "+Ins.alphabet.getSelected());
      p6.doLayout();
      String a = Ins.alphabet.getSelected();
      blank.setChars(a);
      wildcard.setChars(a);
      copy.setChars(a);lambda.setChars(a);}
    
   public void actionPerformed(ActionEvent e){
      Object o = e.getSource();
      if (o instanceof Button){
         String command = ((Button)o).getLabel();
         if(command.equals("Cancel")){dispose();}
         else if(command.equals("Apply") || command.equals("Ok")){
            Ins.alphabet.apply();   
            String a = Ins.alphabet.getAlphabet();
            blank.setChars(a);
            wildcard.setChars(a);
            copy.setChars(a);
            lambda.setChars(a);
            lc.setText("Current alphabet ->  " + a);
            p3.doLayout();
            Ins.alphabet.blank=blank.getSelected();
            Ins.alphabet.copy=copy.getSelected();
            Ins.alphabet.wildcard=wildcard.getSelected();
            Ins.alphabet.lambda=lambda.getSelected();
            if(command.equals("Ok"))dispose();}
         else if(command.equals("Select characters"))
            Ins.alphabet.selectCharacters();
         else if(command.equals("Select digits"))
            Ins.alphabet.selectDigits();
         else if(command.equals("Select all"))
            Ins.alphabet.setAll(true);
         else if(command.equals("Select used")){
            Ins.alphabet.selectUsed();}
         else if(command.equals("Unselect all"))
            Ins.alphabet.setAll(false);
         cs.setText("Current selected -> "+Ins.alphabet.getSelected());
         p6.doLayout();
      }
   }
}
