
package dialog;
import tm2.*;

import java.awt.*;
import mdgawt.*;
import java.awt.event.*;
import java.io.*;

public class ColorDialog extends Dialog implements WindowListener,ActionListener,
                                       ItemListener,SettingListener{
// ----------------------------CLASS DATA------------------------------------
   private static final int numColors = 39;
   public static String[] names = {
      "Graph","Grid","Tape","Tape text",
      "Tape head","Tape head text","Tape selected","Tape selected text",
      "Free text background","Free text foreground","Tag link",
      "State","State number","State ring","State name background",
      "State name foreground","State text background",
      "State text foreground","Machine","Machine number","Machine name background",
      "Machine name foreground","Machine text background","Machine text foreground",
      "Super machine name background","Super machine name foreground",
      "Super machine text background","Super machine text foreground",
      "Instruction link","Instruction arrow","Instruction tab",
      "Instruction tab, current",
      "Instruction name background","Instruction name foreground",
      "Instruction text background","Instruction text foreground",
      "Counter","Counter number","Counter shade"};
// --------------------------INSTANCE DATA-----------------------------------
   public Choice choice,fileChoice;
   public ColorBlock cb;
   public TMG tmg;
   public UpDownCounter red,green,blue;
   public ColorDialog(TMG t){
      super(t.myFrame,"Colors",true);
      tmg=t;
      setSize(350,120);
      setResizable(false);
      Point p1 = tmg.getLocation();
      setLocation(p1.x+20,p1.y+20);
      setLayout(new BorderLayout(4,4));
      cb= new ColorBlock();
      choice = new Choice();
      fileChoice = new Choice();
      red   = new UpDownCounter(0,255);
      red.setColors(Color.black,Color.red,Color.black,Color.white);
      red.addSettingListener(this);
      green = new UpDownCounter(0,255);
      green.setColors(Color.black,Color.green,Color.black,Color.white);
      green.addSettingListener(this);
      blue  = new UpDownCounter(0,255);
      blue.setColors(Color.black,Color.blue,Color.black,Color.white);
      blue.addSettingListener(this);
      Button b1 = new Button("Save As Default");
      b1.addActionListener(this);
      Button b2 = new Button("Load Default");
      b2.addActionListener(this);
      Button b3 = new Button("Save As...");
      b3.addActionListener(this);
      Button b4 = new Button("Load...");
      b4.addActionListener(this);
      Button b5 = new Button("Apply");
      b5.addActionListener(this);
      Button b6 = new Button("Close");
      b6.addActionListener(this);
      for(int i=0;i<numColors;i++)
         choice.addItem(names[i]);
      choice.addItemListener(this);
      red.setValue(TMG.graph.getRed());
      green.setValue(TMG.graph.getGreen());
      blue.setValue(TMG.graph.getBlue());
      cb.color=TMG.graph;
      Panel p = new Panel();
         p.setLayout(new GridLayout(3,3,4,4));        
         p.add(red);p.add(b2);p.add(b4);
         p.add(green);p.add(b1);p.add(b3);
         p.add(blue);p.add(b5);p.add(b6);
      add("North",choice);
      add("West",cb);    
      add("Center",p);
      setVisible(true);}
// ---------------------------------SAVE-------------------------------------
   public static void save(){save(TMG.defaultColorFile);}
   public static void save(String filename){
      try{
         Color c;
         PrintWriter out = new PrintWriter(new FileOutputStream(filename));
         c=TMG.graph;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=TMG.grid;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Tape.tape;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Tape.text;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Tape.head;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Tape.headText;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Tape.selected;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Tape.selectedText;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=FTA.free;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=FTA.freeText;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=FTA.tagLink;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=State.state;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=State.stateNumber;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=State.stateRing;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=State.nameBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=State.nameForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=State.textBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=State.textForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Machine.machine;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Machine.number;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Machine.nameBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Machine.nameForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Machine.textBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Machine.textForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=SuperMachine.nameBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=SuperMachine.nameForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=SuperMachine.textBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=SuperMachine.textForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.link;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.arrow;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.tab;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.current;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.nameBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.nameForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.textBackground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=Ins.textForeground;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=BigCounter.counter;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=BigCounter.number;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         c=BigCounter.shade;
         out.println(new String(""+c.getRed()+';'+c.getGreen()+';'+c.getBlue()+';'));
         out.close();
     }catch(IOException e){
        System.err.println(e);
        return;}
   }
// ---------------------------------LOAD-------------------------------------
   public static void load(){load(new String(TMG.defaultColorFile));}
   public static void load(String filename){
      try{
         StreamTokenizer s = new StreamTokenizer(new BufferedReader
                            (new InputStreamReader(new FileInputStream(filename))));
         s.whitespaceChars(';',';');
         int token,r,g,b;
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         TMG.graph=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         TMG.grid=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Tape.tape=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Tape.text=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Tape.head=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Tape.headText=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Tape.selected=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Tape.selectedText=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         FTA.free=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         FTA.freeText=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         FTA.tagLink=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         State.state=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         State.stateNumber=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         State.stateRing=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         State.nameBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         State.nameForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         State.textBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         State.textForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Machine.machine=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Machine.number=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Machine.nameBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Machine.nameForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Machine.textBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Machine.textForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         SuperMachine.nameBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         SuperMachine.nameForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         SuperMachine.textBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         SuperMachine.textForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.link=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.arrow=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.tab=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.current=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.nameBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.nameForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.textBackground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         Ins.textForeground=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         BigCounter.counter=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         BigCounter.number=new Color(r,g,b);
         s.nextToken();r=(int)(s.nval);s.nextToken();g=(int)(s.nval);s.nextToken();b=(int)(s.nval);
         BigCounter.shade=new Color(r,g,b);
      }catch(IOException e){
          System.err.println(e);
          return;}
  }   
// ---------------------------------EVENTS-------------------------------------
   public void itemStateChanged(ItemEvent e){
      Color current;
      Object c = e.getSource();
      String command = ((Choice)c).getSelectedItem();
      if(command.equals(names[0]))current=TMG.graph;
      else if(command.equals(names[1]))current=TMG.grid;
      else if(command.equals(names[2]))current=Tape.tape;
      else if(command.equals(names[3]))current=Tape.text;
      else if(command.equals(names[4]))current=Tape.head;
      else if(command.equals(names[5]))current=Tape.headText;
      else if(command.equals(names[6]))current=Tape.selected;
      else if(command.equals(names[7]))current=Tape.selectedText;
      else if(command.equals(names[8]))current=FTA.free;
      else if(command.equals(names[9]))current=FTA.freeText;
      else if(command.equals(names[10]))current=FTA.tagLink;
      else if(command.equals(names[11]))current=State.state;
      else if(command.equals(names[12]))current=State.stateNumber;
      else if(command.equals(names[13]))current=State.stateRing;
      else if(command.equals(names[14]))current=State.nameBackground;
      else if(command.equals(names[15]))current=State.nameForeground;
      else if(command.equals(names[16]))current=State.textBackground;
      else if(command.equals(names[17]))current=State.textForeground;
      else if(command.equals(names[18]))current=Machine.machine;
      else if(command.equals(names[19]))current=Machine.number;
      else if(command.equals(names[20]))current=Machine.nameBackground;
      else if(command.equals(names[21]))current=Machine.nameForeground;
      else if(command.equals(names[22]))current=Machine.textBackground;
      else if(command.equals(names[23]))current=Machine.textForeground;
      else if(command.equals(names[24]))current=SuperMachine.nameBackground;
      else if(command.equals(names[25]))current=SuperMachine.nameForeground;
      else if(command.equals(names[26]))current=SuperMachine.textBackground;
      else if(command.equals(names[27]))current=SuperMachine.textForeground;
      else if(command.equals(names[28]))current=Ins.link;
      else if(command.equals(names[29]))current=Ins.arrow;
      else if(command.equals(names[30]))current=Ins.tab;
      else if(command.equals(names[31]))current=Ins.current;
      else if(command.equals(names[32]))current=Ins.nameBackground;
      else if(command.equals(names[33]))current=Ins.nameForeground;
      else if(command.equals(names[34]))current=Ins.textBackground;
      else if(command.equals(names[35]))current=Ins.textForeground;
      else if(command.equals(names[36]))current=BigCounter.counter;
      else if(command.equals(names[37]))current=BigCounter.number;
      else if(command.equals(names[38]))current=BigCounter.shade;
      else current = Color.white;
      red.setValue(current.getRed());
      green.setValue(current.getGreen());
      blue.setValue(current.getBlue());
      cb.color=current;
      cb.repaint();}
   public void actionPerformed(ActionEvent e){
      Object o = e.getSource();
      if (o instanceof Button){
         String command = ((Button)o).getLabel();
         if(command.equals("Save As Default")){save(tmg.defaultColorFile);}
         else if(command.equals("Load Default")){
            load(tmg.defaultColorFile);
            tmg.repaintEverything();dispose();
         }else if(command.equals("Save As...")){
            FileDialog f = new FileDialog(tmg.myFrame,"Save Colors",FileDialog.SAVE);
            f.setFile("*.pal");
            f.show();
            String filename = f.getFile();
            if(filename!=null)save(filename);
         }else if(command.equals("Load...")){
            FileDialog f = new FileDialog(tmg.myFrame,"Load Colors",FileDialog.LOAD);
            f.setFile("*.pal");
            f.show();
            String filename = f.getFile();
            if(filename!=null)load(filename);
            tmg.repaintEverything();
         }else if(command.equals("Close")){
            tmg.repaintEverything();
            dispose();
         }else if(command.equals("Apply")){
            String c = choice.getSelectedItem();
            Color newColor = new Color(cb.color.getRed(),cb.color.getGreen(),
                                 cb.color.getBlue());
            if(c.equals(names[0]))TMG.graph=newColor;
            else if(c.equals(names[1]))TMG.grid=newColor;
            else if(c.equals(names[2]))Tape.tape=newColor;
            else if(c.equals(names[3]))Tape.text=newColor;
            else if(c.equals(names[4]))Tape.head=newColor;
            else if(c.equals(names[5]))Tape.headText=newColor;
            else if(c.equals(names[6]))Tape.selected=newColor;
            else if(c.equals(names[7]))Tape.selectedText=newColor;
            else if(c.equals(names[8]))FTA.free=newColor;
            else if(c.equals(names[9]))FTA.freeText=newColor;
            else if(c.equals(names[10]))FTA.tagLink=newColor;
            else if(c.equals(names[11]))State.state=newColor;
            else if(c.equals(names[12]))State.stateNumber=newColor;
            else if(c.equals(names[13]))State.stateRing=newColor;
            else if(c.equals(names[14]))State.nameBackground=newColor;
            else if(c.equals(names[15]))State.nameForeground=newColor;
            else if(c.equals(names[16]))State.textBackground=newColor;
            else if(c.equals(names[17]))State.textForeground=newColor;
            else if(c.equals(names[18]))Machine.machine=newColor;
            else if(c.equals(names[19]))Machine.number=newColor;
            else if(c.equals(names[20]))Machine.nameBackground=newColor;
            else if(c.equals(names[21]))Machine.nameForeground=newColor;
            else if(c.equals(names[22]))Machine.textBackground=newColor;
            else if(c.equals(names[23]))Machine.textForeground=newColor;
            else if(c.equals(names[24]))SuperMachine.nameBackground=newColor;
            else if(c.equals(names[25]))SuperMachine.nameForeground=newColor;
            else if(c.equals(names[26]))SuperMachine.textBackground=newColor;
            else if(c.equals(names[27]))SuperMachine.textForeground=newColor;
            else if(c.equals(names[28]))Ins.link=newColor;
            else if(c.equals(names[29]))Ins.arrow=newColor;
            else if(c.equals(names[30]))Ins.tab=newColor;
            else if(c.equals(names[31]))Ins.current=newColor;
            else if(c.equals(names[32]))Ins.nameBackground=newColor;
            else if(c.equals(names[33]))Ins.nameForeground=newColor;
            else if(c.equals(names[34]))Ins.textBackground=newColor;
            else if(c.equals(names[35]))Ins.textForeground=newColor;
            else if(c.equals(names[36]))BigCounter.counter=newColor;
            else if(c.equals(names[37]))BigCounter.number=newColor;
            else if(c.equals(names[38]))BigCounter.shade=newColor;
            tmg.repaintEverything();
         }
      }
   }
// ------------------------SETTING EVENTS--------------------------------------
   public void settingChanged(SettingEvent e){
      cb.color=new Color(red.getValue(),green.getValue(),blue.getValue());
      cb.repaint();}
//-----------------------------Events--------------------------------         
   public void windowOpened(WindowEvent e){}
   public void windowClosing(WindowEvent e){setVisible(false);}
   public void windowClosed(WindowEvent e){}
   public void windowIconified(WindowEvent e){}
   public void windowDeiconified(WindowEvent e){}
   public void windowActivated(WindowEvent e){}
   public void windowDeactivated(WindowEvent e){}
}

class ColorBlock extends Canvas{
   public Color color = Color.white;;
   public ColorBlock(){setSize(40,80);}
   public void update(Graphics g){paint(g);}
   public void paint(Graphics g){
      g.setColor(Color.black);
      g.drawRect(0,0,39,39);
      g.setColor(color);
      g.fillRect(1,1,38,38);}
}




