
package dialog;
import tm2.*;

import java.awt.*;
import mdgawt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class InsDialog extends Dialog implements ActionListener,ItemListener{
 //     CharacterSelector[] reads  = new CharacterSelector[Tape.getNumTapes()];
 //     CharacterSelector[] writes = new CharacterSelector[Tape.getNumTapes()];
      Choice[] directions = new Choice[Tape.getNumTapes()];
      Choice[] reads      = new Choice[Tape.getNumTapes()];
      Choice[] writes     = new Choice[Tape.getNumTapes()];
      Ins ins;
   public InsDialog(MyCanvas t,Ins in){
      super(t.myFrame,"Instruction",true);
      ins=in;
      setSize(300,(Tape.getNumTapes()+3)*40);
      setResizable(false);
      Point p1 = t.getLocation();
      Dimension d = t.getSize();
      String alpha = Ins.alphabet.getAlphabet();
      setLocation(p1.x+d.width/2-150,p1.y+d.height/2-(Tape.getNumTapes()+2)*20);
      setLayout(new GridLayout((Tape.getNumTapes()+2),1,5,5));
     int type = TMG.getType();
     Panel p = new Panel();
         p.setLayout(new FlowLayout(1,5,5));
         p.add(new Label("Tape"));
         p.add(new Label("Read"));
         if(type==TMG.TM || type==TMG.PDA){
            p.add(new Label("Write"));
            p.add(new Label("Direction"));}
         add(p);
      for(int i=0;i<Tape.getNumTapes();i++){
         p = new Panel();
            reads[i] = new Choice();
            for(int j=0;j<alpha.length();j++)reads[i].add(""+alpha.charAt(j));
            reads[i].select(""+ins.getRead(i));
            writes[i] = new Choice();
            for(int j=0;j<alpha.length();j++)writes[i].add(""+alpha.charAt(j));
            writes[i].select(""+ins.getWrite(i));
            directions[i] = new Choice();
            directions[i].add("Right");
            directions[i].add("Stay");
            if(type!=TMG.PDA || i!=0){
               directions[i].add("Left");}
            if(ins.getDirection(i)==Ins.RIGHT)directions[i].select("Right");
            else if(ins.getDirection(i)==Ins.LEFT)directions[i].select("Left");
            else directions[i].select("Stay");
            p.add(new Label(""+Integer.toString(i+1)));
            p.add(reads[i]);
            if(type==TMG.TM || type==TMG.PDA){
               p.add(writes[i]);
               p.add(directions[i]);}
            add(p);}
      if(type==TMG.PDA){
           writes[0].setEnabled(false);
           reads[0].addItemListener(this);
           writes[1].addItemListener(this);
           directions[1].addItemListener(this);}
      p = new Panel();      
         Button b = new Button("Ok");
         b.addActionListener(this);
         p.add(b);
         b = new Button("Cancel");
         b.addActionListener(this);
         p.add(b);
         add(p);}
   public void itemStateChanged(ItemEvent e){
      writes[0].select(reads[0].getSelectedItem());
      if(directions[1].getSelectedItem().equals("Left")){
         writes[1].select(""+Alphabet.blank);
         writes[1].setEnabled(false);}
      else writes[1].setEnabled(true);}
   public void actionPerformed(ActionEvent e){
       Object c = e.getSource();
       char[] chars = new char[Tape.maxTapes];
       if (c instanceof Button){
         String command = ((Button)c).getLabel();
         if(command.equals("Ok")){
            for(int i=0;i<Tape.getNumTapes();i++)
               chars[i]=reads[i].getSelectedItem().charAt(0);
            if(((TMG)ins.getOwner()).changeIns(ins,chars)){
               for(int i=0;i<Tape.getNumTapes();i++){
                  ins.setRead(i,chars[i]);
                  ins.setWrite(i,writes[i].getSelectedItem().charAt(0));
                  ins.setDirection(i,directions[i].getSelectedItem().charAt(0));}
               ins.getOwner().fullRepaint();
               dispose();}
            else{
               WarningDialog wd = new WarningDialog(ins.getOwner().myFrame,"",
                               "This is not a non-deterministic machine");}
         }
         else if(command.equals("Cancel")){
            dispose();}
      }
   }
}

