
package mdgawt;
import java.awt.*;
import java.util.*;

public class MyComponent extends Canvas{
// ----------------------------CLASS DATA------------------------------------
   public  static final int LINE  = 1;
   public  static final int BARC  = 2;
   public  static final int HARC  = 3;
   public String[] arcNames = {"Line","Bezier Curve","Hermite Curve"};
   public  static int defaultType = LINE;
   public  static boolean lockLinks = true;  // drag with
   public  static Color link           = Color.red;
   public  static Color arrow          = Color.black;
// --------------------------INSTANCE DATA-----------------------------------
   protected MyCanvas parent;
   public String saveName = new String("");
   public String savePath = new String("");
   public boolean isRemovable = true;
   public int travelx = (int)(Math.random()*5);
   public int travely = (int)(Math.random()*5);
   public int arcType             = defaultType;
   private String name = new String("");
   protected MyCanvas myChild;
   public Color foreground= new Color(0,0,0);
   public Color background= new Color(0,0,0);
   public boolean visible = true;
   public boolean active = false;
   public boolean isLinkable = false;
   public Vector links = new Vector(0);
   public int x,y,width,height;
// ----------------------------CONSTRUCTOR-----------------------------------
   public MyComponent(){}
   public MyComponent(String s,int xx,int yy){
      setText(s);setLocation(xx,yy);}
   public boolean isLinkedTo(MyComponent mc){
      for(int i=0;i<links.size();i++)
          if(links.elementAt(i)==mc)return true;
      return false;}
   public void removeAllLinks(){
      links = new Vector(0);}
   public void removeLink(MyComponent m){links.removeElement(m);}
   public void addLink(MyComponent m){links.addElement(m);}
// -------------------------------SETS---------------------------------------
//   public void setFont(Font c){font=c;}
   public void setArcType(int n){arcType=n;}
   public void setForeground(Color c){foreground=c;}
   public void setBackground(Color c){background=c;}
   public void setVisible(boolean b){visible=b;}
   public void setSize(int w,int h){width=w;height=h;}
   public void setLocation(int xx,int yy){x=xx;y=yy;}
   public void setCenter(int xx,int yy){
      x=xx-height/2;y=yy-height/2;}
   public void setText(String st){name=st;}
   public void setOwner(MyCanvas mc){parent=mc;}
// -------------------------------GETS---------------------------------------
   public void setActive(boolean b){active = b;}
   public boolean isActive(){return active;}
   public MyCanvas getOwner(){return parent;}
   public MyCanvas getChild(){return myChild;}
   public MyComponent getLink(int n){
      if(n<0 || n >=links.size())return null;
      return ((MyComponent)links.elementAt(n));}
//   public Font getFont(){return font;}
   public Color getNameForeground(){return foreground;}
   public Color getNameBackground(){return background;}
   public Color getTextForeground(){return foreground;}
   public Color getTextBackground(){return background;}
   public Color getForeground(){return foreground;}
   public Color getBackground(){return background;}
   public Point getCenter(){return new Point(x+width/2,y+height/2);}
   public Point getLocation(){return new Point(x,y);}
   public Point getTravel(){return new Point(travelx,travely);}
   public Dimension getSize(){return new Dimension(width,height);}
   public String getArcName(){return arcNames[arcType-1];}
   public String getText(){return name;}
//--------------------------------METHODS------------------------------------
   public void grabClosest(){}
   public boolean clip(Rectangle r){
      Point rp = r.getLocation();
      Dimension rd = r.getSize();
      if(x+width<rp.x || x>rp.x+rd.width ||
         y+height<rp.y || y>rp.y+rd.width)return true;
      return false;}
   public boolean isVisible(){return visible;}
   public void translate(int xx, int yy){x+=xx;y+=yy;}	
   public boolean isInside(int a,int b){
      return (a>=x && b>=y && a<(x+width)&& b<(y+height));}
   public boolean intersects(MyComponent mc){
      if(mc.x>x+width || mc.x+mc.width<x ||
         mc.y>y+height || mc.y+mc.height<y)return false;
      return true;}
   public void add(MyPopup c){}
   public void createPopupMenu(MyCanvas comp){}
   public void createDialog(Component c){}
   public static MyComponent fromString(String st){return null;}
   public String toString(){
      return new String('"'+name+'"'+';'+x+';'+y+';'+width+';'+height+';');}
//---------------------------------PAINT-------------------------------------
   public void paintLink(Graphics g){
      if(g==null)return;
      Point p3 = getCenter();
      for(int k=1;k<links.size();k++){   
         Point p1 = ((MyComponent)links.elementAt(0)).getCenter();
         Point p2 = ((MyComponent)links.elementAt(k)).getCenter();
         g.setColor(link);
         if(arcType==LINE){
            float dx,dy,n;
            dx=p2.x-p3.x;dy=p2.y-p3.y;
            n= (float)(Math.sqrt((dx*dx)+(dy*dy))/20.0);
            Point p4 = new Point((int)((dx/n)+p3.x),(int)((dy/n)+p3.y));
            if(p1==p2)p4=p3;
            g.drawLine(p1.x,p1.y,p3.x,p3.y);
            g.drawLine(p2.x,p2.y,p4.x,p4.y);
            g.setColor(arrow);
            if(p1!=p2)for(int i=-4;i<=4;i++){
               g.drawLine(p4.x,p4.y,p3.x+i,p3.y);            
               g.drawLine(p4.x,p4.y,p3.x,p3.y+i);}  
         }          
         else if(arcType==BARC || arcType==HARC){
           boolean on = false;
           Vector2d v1,v2,v3,v4,tt;
           double DEG270 = (3.0*Math.PI)/2.0;
           double DEG90 = Math.PI/2.0;
           FPoint pp,pp2;int cc=0;
           FPoint temp = new FPoint(p2.x-p1.x,p2.y-p1.y);
           if(p1.x==p2.x && p1.y==p2.y){  // This is a loop.
              tt = new Vector2d(p3.x-p1.x,p3.y-p1.y);
              v1 = new Vector2d(tt.x,tt.y);v1.rotate(20);
              v2 = new Vector2d(tt.x,tt.y);v2.rotate(270);
              v3 = new Vector2d(tt.x,tt.y);v3.rotate(160);
           }else{  
              v2 = new Vector2d(temp.x,temp.y);
              v4 = new Vector2d(p3.x-p1.x,p3.y-p1.y);     
              v1 = new Vector2d(p3.x-p1.x,p3.y-p1.y);
              v3 = new Vector2d(p2.x-p3.x,p2.y-p3.y);
              double v2v4 = Math.acos((v2.x*v4.x+v2.y*v4.y)/
                        (Math.sqrt(v2.x*v2.x + v2.y*v2.y)*
                         Math.sqrt(v4.x*v4.x + v4.y*v4.y)));
              if(v2v4>Math.PI){
                 v1.x=-v1.x;v1.y=-v1.y;
                 v3.x=-v3.x;v3.y=-v3.y;}
           }
           Vector p,q;
           if(arcType==HARC){
              p=getARC(p1,v1,v2,p3,g);
              q=getARC(p3,v2,v3,p2,g);}
           else{
              p=getBezierArc(p1,p3,p3,p2,g);
              q=new Vector();//getBezierArc(p3,v2,v3,p2,g);
           }
           for(int r=0;r<q.size();r++)
              p.addElement(q.elementAt(r));
           double closest = 10000;FPoint tip = new FPoint(x,y);
           // find arrow tip
           double distcp2=Math.sqrt(((p3.x-p2.x)*(p3.x-p2.x))+
                                 ((p3.y-p2.y)*(p3.y-p2.y)));
           for(int i=p.size()/2;i<p.size();i++){
              pp = ((FPoint)p.elementAt(i));
              double dist = Math.sqrt(((p3.x-pp.x)*(p3.x-pp.x))+
                                      ((p3.y-pp.y)*(p3.y-pp.y)));
              double off = Math.abs(Math.abs(dist)-20);
              if(off<closest)  // right direction
                 if(Math.sqrt(((p2.x-pp.x)*(p2.x-pp.x))+
                                          ((p2.y-pp.y)*(p2.y-pp.y)))<distcp2){
                    closest =  off;tip = pp;
                 }
            }
           // draw the arc
           g.setColor(link);
           for(int i=0;i<p.size()-1;i++){
              pp =  ((FPoint)p.elementAt(i));
              pp2 = ((FPoint)p.elementAt(i+1));
              g.drawLine(((int)pp.x),((int)pp.y),((int)pp2.x),((int)pp2.y));}
           //draw arrow
           g.setColor(arrow);
           for(int i=-4;i<=4;i++){
              g.drawLine(((int)tip.x),((int)tip.y),p3.x+i,p3.y);            
              g.drawLine(((int)tip.x),((int)tip.y),p3.x,p3.y+i);}
         } // end if parc
      }
   }
   private Vector getARC(Point p1,Vector2d p2,Vector2d p3,Point p4,Graphics g){
      Vector points = new Vector();
      double n=20,x,y,t,t2,t3,delta;
      delta=1.0/n;
      for(int i=0;i<n;i++){
         t = i*delta;
         t2 = t*t;
         t3 = t2*t;
         x = (2*t3-3*t2+1)*p1.x+(-2*t3+3*t2)*p4.x+
             (t3-2*t2+t)*p2.x+(t3-t2)*p3.x;
         y = (2*t3-3*t2+1)*p1.y+(-2*t3+3*t2)*p4.y+
             (t3-2*t2+t)*p2.y+(t3-t2)*p3.y;
         points.addElement(new FPoint(x,y));
      }
   return points;}
   private Vector getBezierArc(Point p1, Point p2,Point p3,Point p4,Graphics g){
      Vector points = new Vector();
      double n=20,x,y,t,t2,t3,ti,ti2,ti3,delta;
      delta=1.0/n;
      for(int i=0;i<n;i++){
         t = (1-i*delta);
         t2 = t*t;
         t3 = t2*t;
         ti = (1-t);
         ti2 = ti*ti;
         ti3 = ti2*ti;
         x = ti3*p1.x+3*t*ti2*p2.x+
             3*t2*ti*p3.x+t3*p4.x;
         y = ti3*p1.y+3*t*ti2*p2.y+
             3*t2*ti*p3.y+t3*p4.y;
         points.addElement(new FPoint(x,y));
      }
   return points;}
}
