
package mdgawt;
import java.awt.*;

public class Vector2d{
   public double x,y;
   public Vector2d(double x,double y){
      this.x=x;this.y=y;}
   public Vector2d(FPoint p1, FPoint p2){
      x=p2.x-p1.x; y=p2.y-p1.y;}
   public Vector2d getScaled(double f){return new Vector2d(x*f,y*f);}
   public Vector2d subtract(Vector2d rt){
      return new Vector2d(x-rt.x,y-rt.y);}
   public static double angleBetween(Vector2d v1, Vector2d v2){
      return Math.acos((v1.dotProduct(v2))/(v1.norm()*v2.norm()));}
   public double dotProduct(Vector2d rt){
      return((x * rt.x) + (y * rt.y));}
   public void normalize(){double n = norm();x=x/n;y=y/n;}
   public void rotate(double ang){
      double rad = (ang*Math.PI)/180.0;
      double temp = x;
      x=x*Math.cos(rad)-y*Math.sin(rad);
      y=temp*Math.sin(rad)+y*Math.cos(rad);}
   public double norm(){
      return Math.sqrt(x*x + y*y);}
//   public Vector2d crossProduct(Vector2d rt){
//      return new Vector3d((y*rt.z - z*rt.y),-(x*rt.z - z*rt.x),(x*rt.y - y*rt.x));}
   public static double distance(FPoint p1, FPoint p2){
      return Math.sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));}
   public String toString(){
      return new String("("+x+","+y+")");}
}

